Index: issm/trunk/src/m/classes/matice.py
===================================================================
--- issm/trunk/src/m/classes/matice.py	(revision 13395)
+++ issm/trunk/src/m/classes/matice.py	(revision 13395)
@@ -0,0 +1,126 @@
+#module imports
+from fielddisplay import fielddisplay
+from EnumDefinitions import *
+from StringToEnum import StringToEnum
+from checkfield import *
+from WriteData import *
+
+class matice(object):
+	"""
+	MATERIALS class definition
+
+	   Usage:
+	      matice=matice();
+	"""
+
+	#properties
+	def __init__(self):
+		# {{{ Properties
+		self.rho_ice                    = 0.
+		self.rho_water                  = 0.
+		self.rho_freshwater             = 0.
+		self.mu_water                   = 0.
+		self.heatcapacity               = 0.
+		self.latentheat                 = 0.
+		self.thermalconductivity        = 0.
+		self.meltingpoint               = 0.
+		self.beta                       = 0.
+		self.mixed_layer_capacity       = 0.
+		self.thermal_exchange_velocity  = 0.
+		self.rheology_B   = float('NaN')
+		self.rheology_n   = float('NaN')
+		self.rheology_law = ''
+
+		self.setdefaultparameters()
+		#}}}
+	def __repr__(self):
+		# {{{ Display
+		string="   Materials:"
+
+		string="%s\n\n%s"%(string,fielddisplay(self,"rho_ice","ice density [kg/m^3]"))
+		string="%s\n%s"%(string,fielddisplay(self,"rho_water","water density [kg/m^3]"))
+		string="%s\n%s"%(string,fielddisplay(self,"rho_freshwater","fresh water density [kg/m^3]"))
+		string="%s\n%s"%(string,fielddisplay(self,"mu_water","water viscosity [N s/m^2]"))
+		string="%s\n%s"%(string,fielddisplay(self,"heatcapacity","heat capacity [J/kg/K]"))
+		string="%s\n%s"%(string,fielddisplay(self,"thermalconductivity","ice thermal conductivity [W/m/K]"))
+		string="%s\n%s"%(string,fielddisplay(self,"meltingpoint","melting point of ice at 1atm in K"))
+		string="%s\n%s"%(string,fielddisplay(self,"latentheat","latent heat of fusion [J/m^3]"))
+		string="%s\n%s"%(string,fielddisplay(self,"beta","rate of change of melting point with pressure [K/Pa]"))
+		string="%s\n%s"%(string,fielddisplay(self,"mixed_layer_capacity","mixed layer capacity [W/kg/K]"))
+		string="%s\n%s"%(string,fielddisplay(self,"thermal_exchange_velocity","thermal exchange velocity [m/s]"))
+		string="%s\n%s"%(string,fielddisplay(self,"rheology_B","flow law parameter [Pa/s^(1/n)]"))
+		string="%s\n%s"%(string,fielddisplay(self,"rheology_n","Glen's flow law exponent"))
+		string="%s\n%s"%(string,fielddisplay(self,"rheology_law","law for the temperature dependance of the rheology: 'None', 'Paterson' or 'Arrhenius'"))
+
+		return string
+		#}}}
+	def setdefaultparameters(self):
+		# {{{setdefaultparameters
+		#ice density (kg/m^3)
+		self.rho_ice=917.
+
+		#ocean water density (kg/m^3)
+		self.rho_water=1023.
+
+		#fresh water density (kg/m^3)
+		self.rho_freshwater=1000.
+
+		#water viscosity (N.s/m^2)
+		self.mu_water=0.001787  
+
+		#ice heat capacity cp (J/kg/K)
+		self.heatcapacity=2093.
+
+		#ice latent heat of fusion L (J/kg)
+		self.latentheat=3.34*10**5
+
+		#ice thermal conductivity (W/m/K)
+		self.thermalconductivity=2.4
+
+		#the melting point of ice at 1 atmosphere of pressure in K
+		self.meltingpoint=273.15
+
+		#rate of change of melting point with pressure (K/Pa)
+		self.beta=9.8*10**-8
+
+		#mixed layer (ice-water interface) heat capacity (J/kg/K)
+		self.mixed_layer_capacity=3974.
+
+		#thermal exchange velocity (ice-water interface) (m/s)
+		self.thermal_exchange_velocity=1.00*10**-4
+
+		#Rheology law: what is the temperature dependence of B with T
+		#available: none, paterson and arrhenius
+		self.rheology_law='Paterson'
+		return self
+		#}}}
+
+	def checkconsistency(self,md,solution,analyses):    # {{{
+		md = checkfield(md,'materials.rho_ice','>',0)
+		md = checkfield(md,'materials.rho_water','>',0)
+		md = checkfield(md,'materials.rho_freshwater','>',0)
+		md = checkfield(md,'materials.mu_water','>',0)
+		md = checkfield(md,'materials.rheology_B','>',0,'size',[md.mesh.numberofvertices])
+		md = checkfield(md,'materials.rheology_n','>',0,'size',[md.mesh.numberofelements])
+		md = checkfield(md,'materials.rheology_law','values',['None','Paterson','Arrhenius'])
+		return md
+	# }}}
+
+	def marshall(self,fid):    # {{{
+		WriteData(fid,'enum',MaterialsEnum(),'data',MaticeEnum(),'format','Integer');
+		WriteData(fid,'object',self,'class','materials','fieldname','rho_ice','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','rho_water','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','rho_freshwater','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','mu_water','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','heatcapacity','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','latentheat','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','thermalconductivity','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','meltingpoint','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','beta','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','mixed_layer_capacity','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','thermal_exchange_velocity','format','Double')
+		WriteData(fid,'object',self,'class','materials','fieldname','rheology_B','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'class','materials','fieldname','rheology_n','format','DoubleMat','mattype',2)
+		WriteData(fid,'data',StringToEnum(self.rheology_law)[0],'enum',MaterialsRheologyLawEnum(),'format','Integer')
+	# }}}
+
Index: issm/trunk/src/m/classes/mesh.m
===================================================================
--- issm/trunk/src/m/classes/mesh.m	(revision 12709)
+++ issm/trunk/src/m/classes/mesh.m	(revision 13395)
@@ -57,5 +57,5 @@
 		function obj = setdefaultparameters(obj) % {{{
 
-			%the connectivity is the avergaded number of nodes linked to a
+			%the connectivity is the averaged number of nodes linked to a
 			%given node through an edge. This connectivity is used to initially
 			%allocate memory to the stiffness matrix. A value of 16 seems to
@@ -87,4 +87,8 @@
 			md = checkfield(md,'mesh.vertexonbed','size',[md.mesh.numberofvertices 1],'values',[0 1]);
 			md = checkfield(md,'mesh.vertexonsurface','size',[md.mesh.numberofvertices 1],'values',[0 1]);
+			if (md.mesh.dimension==3),
+				md = checkfield(md,'mesh.z','>=',md.geometry.bed-10^-10,'message','''mesh.z'' lower than bedrock');
+				md = checkfield(md,'mesh.z','<=',md.geometry.surface+10^-10,'message','''mesh.z'' higher than surface elevation');
+			end
 			if (md.mesh.dimension==2),
 				md = checkfield(md,'mesh.average_vertex_connectivity','>=',9,'message','''mesh.average_vertex_connectivity'' should be at least 9 in 2d');
@@ -96,5 +100,5 @@
 			%Solution specific checks
 			switch(solution),
-				case PrognosticSolutionEnum,
+				case PrognosticSolutionEnum(),
 					if md.prognostic.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
@@ -102,5 +106,5 @@
 						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
-				case BalancethicknessSolutionEnum,
+				case BalancethicknessSolutionEnum(),
 					if md.balancethickness.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
@@ -108,5 +112,5 @@
 						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
-				case TransientSolutionEnum,
+				case TransientSolutionEnum(),
 					if md.transient.isprognostic & md.prognostic.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
@@ -114,5 +118,5 @@
 						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
-				case ThermalSolutionEnum,
+				case ThermalSolutionEnum(),
 					md = checkfield(md,'mesh.dimension','values',3,'message','thermal solution only supported on 3d meshes');
 			end
Index: issm/trunk/src/m/classes/mesh.py
===================================================================
--- issm/trunk/src/m/classes/mesh.py	(revision 12709)
+++ issm/trunk/src/m/classes/mesh.py	(revision 13395)
@@ -1,6 +1,17 @@
 #module imports
+import numpy
 from fielddisplay import fielddisplay
-
-class mesh:
+from EnumDefinitions import *
+from checkfield import *
+from MatlabFuncs import *
+
+class mesh(object):
+	"""
+	MESH class definition
+
+	   Usage:
+	      mesh=mesh();
+	"""
+
 	#properties
 	def __init__(self):
@@ -50,76 +61,141 @@
 
 		#}}}
-	def __repr__(obj):
+	def __repr__(self):
 		# {{{ Display
 
-		if obj.dimension==3:
+		if self.dimension==3:
 			string="\n%s"%("      Elements and vertices of the original 2d mesh:")
 			
-			string="%s\n%s"%(string,fielddisplay(obj,"numberofelements2d","number of elements"))
-			string="%s\n%s"%(string,fielddisplay(obj,"numberofvertices2d","number of vertices"))
-			string="%s\n%s"%(string,fielddisplay(obj,"elements2d","index into (x,y,z), coordinates of the vertices"))
-			string="%s\n%s"%(string,fielddisplay(obj,"x2d","vertices x coordinate"))
-			string="%s\n%s"%(string,fielddisplay(obj,"y2d","vertices y coordinate"))
+			string="%s\n%s"%(string,fielddisplay(self,"numberofelements2d","number of elements"))
+			string="%s\n%s"%(string,fielddisplay(self,"numberofvertices2d","number of vertices"))
+			string="%s\n%s"%(string,fielddisplay(self,"elements2d","index into (x,y,z), coordinates of the vertices"))
+			string="%s\n%s"%(string,fielddisplay(self,"x2d","vertices x coordinate"))
+			string="%s\n%s"%(string,fielddisplay(self,"y2d","vertices y coordinate"))
 
 			string="%s\n%s" %(string,"Elements and vertices of the extruded 3d mesh:")
 		else:
 			string="\n%s"%("      Elements and vertices:")
-
-		string="%s\n%s"%(string,fielddisplay(obj,"numberofelements","number of elements"))
-		
-
-
-
-		string="%s\n%s"%(string,fielddisplay(obj,"numberofvertices","number of vertices"))
-		string="%s\n%s"%(string,fielddisplay(obj,"elements","index into (x,y,z), coordinates of the vertices"))
-		string="%s\n%s"%(string,fielddisplay(obj,"x","vertices x coordinate"))
-		string="%s\n%s"%(string,fielddisplay(obj,"y","vertices y coordinate"))
-		string="%s\n%s"%(string,fielddisplay(obj,"z","vertices z coordinate"))
-		string="%s\n%s"%(string,fielddisplay(obj,"edges","edges of the 2d mesh (vertex1 vertex2 element1 element2)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"numberofedges","number of edges of the 2d mesh"))
+		string="%s\n%s"%(string,fielddisplay(self,"numberofelements","number of elements"))
+		string="%s\n%s"%(string,fielddisplay(self,"numberofvertices","number of vertices"))
+		string="%s\n%s"%(string,fielddisplay(self,"elements","index into (x,y,z), coordinates of the vertices"))
+		string="%s\n%s"%(string,fielddisplay(self,"x","vertices x coordinate"))
+		string="%s\n%s"%(string,fielddisplay(self,"y","vertices y coordinate"))
+		string="%s\n%s"%(string,fielddisplay(self,"z","vertices z coordinate"))
+		string="%s\n%s"%(string,fielddisplay(self,"edges","edges of the 2d mesh (vertex1 vertex2 element1 element2)"))
+		string="%s\n%s"%(string,fielddisplay(self,"numberofedges","number of edges of the 2d mesh"))
 
 		string="%s%s"%(string,"\n      Properties:")
-		
-		string="%s\n%s"%(string,fielddisplay(obj,"dimension","mesh dimension (2d or 3d)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"numberoflayers","number of extrusion layers"))
-		string="%s\n%s"%(string,fielddisplay(obj,"vertexonbed","lower vertices flags list"))
-		string="%s\n%s"%(string,fielddisplay(obj,"elementonbed","lower elements flags list"))
-		string="%s\n%s"%(string,fielddisplay(obj,"vertexonsurface","upper vertices flags list"))
-		string="%s\n%s"%(string,fielddisplay(obj,"elementonsurface","upper elements flags list"))
-		string="%s\n%s"%(string,fielddisplay(obj,"uppervertex","upper vertex list (NaN for vertex on the upper surface)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"upperelements","upper element list (NaN for element on the upper layer)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"lowervertex","lower vertex list (NaN for vertex on the lower surface)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"lowerelements","lower element list (NaN for element on the lower layer"))
-		string="%s\n%s"%(string,fielddisplay(obj,"vertexonboundary","vertices on the boundary of the domain flag list"))
-		
-		string="%s\n%s"%(string,fielddisplay(obj,"segments","edges on domain boundary (vertex1 vertex2 element)"))
-		string="%s\n%s"%(string,fielddisplay(obj,"segmentmarkers","number associated to each segment"))
-		string="%s\n%s"%(string,fielddisplay(obj,"vertexconnectivity","list of vertices connected to vertex_i"))
-		string="%s\n%s"%(string,fielddisplay(obj,"elementconnectivity","list of vertices connected to element_i"))
-		string="%s\n%s"%(string,fielddisplay(obj,"average_vertex_connectivity","average number of vertices connected to one vertex"))
+		string="%s\n%s"%(string,fielddisplay(self,"dimension","mesh dimension (2d or 3d)"))
+		string="%s\n%s"%(string,fielddisplay(self,"numberoflayers","number of extrusion layers"))
+		string="%s\n%s"%(string,fielddisplay(self,"vertexonbed","lower vertices flags list"))
+		string="%s\n%s"%(string,fielddisplay(self,"elementonbed","lower elements flags list"))
+		string="%s\n%s"%(string,fielddisplay(self,"vertexonsurface","upper vertices flags list"))
+		string="%s\n%s"%(string,fielddisplay(self,"elementonsurface","upper elements flags list"))
+		string="%s\n%s"%(string,fielddisplay(self,"uppervertex","upper vertex list (NaN for vertex on the upper surface)"))
+		string="%s\n%s"%(string,fielddisplay(self,"upperelements","upper element list (NaN for element on the upper layer)"))
+		string="%s\n%s"%(string,fielddisplay(self,"lowervertex","lower vertex list (NaN for vertex on the lower surface)"))
+		string="%s\n%s"%(string,fielddisplay(self,"lowerelements","lower element list (NaN for element on the lower layer"))
+		string="%s\n%s"%(string,fielddisplay(self,"vertexonboundary","vertices on the boundary of the domain flag list"))
+		string="%s\n%s"%(string,fielddisplay(self,"segments","edges on domain boundary (vertex1 vertex2 element)"))
+		string="%s\n%s"%(string,fielddisplay(self,"segmentmarkers","number associated to each segment"))
+		string="%s\n%s"%(string,fielddisplay(self,"vertexconnectivity","list of vertices connected to vertex_i"))
+		string="%s\n%s"%(string,fielddisplay(self,"elementconnectivity","list of vertices connected to element_i"))
+		string="%s\n%s"%(string,fielddisplay(self,"average_vertex_connectivity","average number of vertices connected to one vertex"))
 
 		string="%s%s"%(string,"\n      Extracted model:")
-
-		string="%s\n%s"%(string,fielddisplay(obj,"extractedvertices","vertices extracted from the model"))
-		string="%s\n%s"%(string,fielddisplay(obj,"extractedelements","elements extracted from the model"))
+		string="%s\n%s"%(string,fielddisplay(self,"extractedvertices","vertices extracted from the model"))
+		string="%s\n%s"%(string,fielddisplay(self,"extractedelements","elements extracted from the model"))
 
 		string="%s%s"%(string,"\n      Projection:")
-		string="%s\n%s"%(string,fielddisplay(obj,"lat","vertices latitude"))
-		string="%s\n%s"%(string,fielddisplay(obj,"long","vertices longitude"))
-		string="%s\n%s"%(string,fielddisplay(obj,"hemisphere","Indicate hemisphere ""n"" or ""s"" "))
+		string="%s\n%s"%(string,fielddisplay(self,"lat","vertices latitude"))
+		string="%s\n%s"%(string,fielddisplay(self,"long","vertices longitude"))
+		string="%s\n%s"%(string,fielddisplay(self,"hemisphere","Indicate hemisphere 'n' or 's'"))
 		return string
 		#}}}
 		
-	def setdefaultparameters(obj):
+	def setdefaultparameters(self):
 		# {{{setdefaultparameters
 		
-		#the connectivity is the avergaded number of nodes linked to a
+		#the connectivity is the averaged number of nodes linked to a
 		#given node through an edge. This connectivity is used to initially
 		#allocate memory to the stiffness matrix. A value of 16 seems to
 		#give a good memory/time ration. This value can be checked in
 		#trunk/test/Miscellaneous/runme.m
-		obj.average_vertex_connectivity=25
-
-		return obj
+		self.average_vertex_connectivity=25
+
+		return self
 	#}}}
 
+	def checkconsistency(self,md,solution,analyses):    # {{{
+
+		md = checkfield(md,'mesh.x','NaN',1,'size',[md.mesh.numberofvertices])
+		md = checkfield(md,'mesh.y','NaN',1,'size',[md.mesh.numberofvertices])
+		md = checkfield(md,'mesh.z','NaN',1,'size',[md.mesh.numberofvertices])
+		md = checkfield(md,'mesh.elements','NaN',1,'>',0,'values',range(1,md.mesh.numberofvertices+1))
+		if md.mesh.dimension==2:
+			md = checkfield(md,'mesh.elements','size',[md.mesh.numberofelements,3])
+		else:
+			md = checkfield(md,'mesh.elements','size',[md.mesh.numberofelements,6])
+		if numpy.any(numpy.logical_not(ismember(range(1,md.mesh.numberofvertices+1),md.mesh.elements))):
+			md.checkmessage("orphan nodes have been found. Check the mesh outline")
+		md = checkfield(md,'mesh.dimension','values',[2,3])
+		md = checkfield(md,'mesh.numberoflayers','>=',0)
+		md = checkfield(md,'mesh.numberofelements','>',0)
+		md = checkfield(md,'mesh.numberofvertices','>',0)
+		#no checks for numberofedges lat long and hemisphere
+		md = checkfield(md,'mesh.elementonbed','size',[md.mesh.numberofelements],'values',[0,1])
+		md = checkfield(md,'mesh.elementonsurface','size',[md.mesh.numberofelements],'values',[0,1])
+		md = checkfield(md,'mesh.vertexonbed','size',[md.mesh.numberofvertices],'values',[0,1])
+		md = checkfield(md,'mesh.vertexonsurface','size',[md.mesh.numberofvertices],'values',[0,1])
+		if md.mesh.dimension==2:
+			md = checkfield(md,'mesh.average_vertex_connectivity','>=',9,'message',"'mesh.average_vertex_connectivity' should be at least 9 in 2d")
+		else:
+			md = checkfield(md,'mesh.average_vertex_connectivity','>=',24,'message',"'mesh.average_vertex_connectivity' should be at least 24 in 3d")
+		md = checkfield(md,'mesh.elementconnectivity','size',[md.mesh.numberofelements,3],'NaN',1)
+
+		#Solution specific checks
+		if   solution==PrognosticSolutionEnum():
+			if md.prognostic.stabilization==3:
+				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
+				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
+				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
+		elif solution==BalancethicknessSolutionEnum():
+			if md.balancethickness.stabilization==3:
+				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
+				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
+				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
+		elif solution==TransientSolutionEnum():
+			if md.transient.isprognostic and md.prognostic.stabilization==3:
+				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
+				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
+				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
+		elif solution==ThermalSolutionEnum():
+			md = checkfield(md,'mesh.dimension','values',3,'message','thermal solution only supported on 3d meshes')
+
+		return md
+	# }}}
+
+	def marshall(self,fid):    # {{{
+		WriteData(fid,'object',self,'fieldname','x','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','y','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','z','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','elements','format','DoubleMat','mattype',2)
+		WriteData(fid,'object',self,'fieldname','dimension','format','Integer')
+		WriteData(fid,'object',self,'fieldname','numberoflayers','format','Integer')
+		WriteData(fid,'object',self,'fieldname','numberofelements','format','Integer')
+		WriteData(fid,'object',self,'fieldname','numberofvertices','format','Integer')
+		WriteData(fid,'object',self,'fieldname','numberofedges','format','Integer')
+		WriteData(fid,'object',self,'fieldname','elementonbed','format','BooleanMat','mattype',2)
+		WriteData(fid,'object',self,'fieldname','elementonsurface','format','BooleanMat','mattype',2)
+		WriteData(fid,'object',self,'fieldname','vertexonbed','format','BooleanMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','vertexonsurface','format','BooleanMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','lowerelements','format','DoubleMat','mattype',2)
+		WriteData(fid,'object',self,'fieldname','upperelements','format','DoubleMat','mattype',2)
+		WriteData(fid,'object',self,'fieldname','edges','format','DoubleMat','mattype',3)
+		WriteData(fid,'object',self,'fieldname','elementconnectivity','format','DoubleMat','mattype',3)
+		WriteData(fid,'object',self,'fieldname','average_vertex_connectivity','format','Integer')
+		WriteData(fid,'object',self,'fieldname','elements2d','format','DoubleMat','mattype',3)
+		WriteData(fid,'object',self,'fieldname','numberofvertices2d','format','Integer')
+		WriteData(fid,'object',self,'fieldname','numberofelements2d','format','Integer')
+	# }}}
+
Index: issm/trunk/src/m/classes/miscellaneous.m
===================================================================
--- issm/trunk/src/m/classes/miscellaneous.m	(revision 12709)
+++ issm/trunk/src/m/classes/miscellaneous.m	(revision 13395)
@@ -1,3 +1,3 @@
-%MISCELANEOUS class definition
+%MISCELLANEOUS class definition
 %
 %   Usage:
Index: issm/trunk/src/m/classes/miscellaneous.py
===================================================================
--- issm/trunk/src/m/classes/miscellaneous.py	(revision 12709)
+++ issm/trunk/src/m/classes/miscellaneous.py	(revision 13395)
@@ -1,6 +1,17 @@
 #module imports
+from collections import OrderedDict
 from fielddisplay import fielddisplay
+from EnumDefinitions import *
+from checkfield import *
+from WriteData import *
 
-class miscellaneous:
+class miscellaneous(object):
+	"""
+	MISCELLANEOUS class definition
+
+	   Usage:
+	      miscellaneous=miscellaneous();
+	"""
+
 	#properties
 	def __init__(self):
@@ -8,5 +19,5 @@
 		self.notes = ''
 		self.name  = ''
-		self.dummy = {}
+		self.dummy = OrderedDict()
 
 		#set defaults
@@ -14,17 +25,26 @@
 
 		#}}}
-	def __repr__(obj):
+	def __repr__(self):
 		# {{{ Display
 		string='   miscellaneous parameters:'
 
-		string="%s\n\n%s"%(string,fielddisplay(obj,'notes','notes in a cell of strings'))
-		string="%s\n%s"%(string,fielddisplay(obj,'name','model name'))
-		string="%s\n%s"%(string,fielddisplay(obj,'dummy','empty field to store some data'))
+		string="%s\n\n%s"%(string,fielddisplay(self,'notes','notes in a cell of strings'))
+		string="%s\n%s"%(string,fielddisplay(self,'name','model name'))
+		string="%s\n%s"%(string,fielddisplay(self,'dummy','empty field to store some data'))
 		return string
 		#}}}
 		
-	def setdefaultparameters(obj):
+	def setdefaultparameters(self):
 		# {{{setdefaultparameters
-		return obj
+		return self
 	#}}}
 
+	def checkconsistency(self,md,solution,analyses):    # {{{
+		md = checkfield(md,'miscellaneous.name','empty',1)
+		return md
+	# }}}
+
+	def marshall(self,fid):    #  {{{
+		WriteData(fid,'object',self,'fieldname','name','format','String')
+	# }}}
+
Index: issm/trunk/src/m/classes/model/model.m
===================================================================
--- issm/trunk/src/m/classes/model/model.m	(revision 12709)
+++ issm/trunk/src/m/classes/model/model.m	(revision 13395)
@@ -72,4 +72,15 @@
 				 md = structtomodel(model,md);
 			 end
+
+			 %2012 August 4th
+			 if isa(md.materials,'materials'),
+				 disp('Recovering old materials');
+				 if numel(md.materials.rheology_Z)==1 & isnan(md.materials.rheology_Z),
+					 md.materials=matice(md.materials);
+				 else
+					 md.materials=matdamageice(md.materials);
+				 end
+			 end
+
 		 end% }}}
 	 end
